/* BresenClock.h */
#ifndef BRESENCLOCK_H

  #define BRESENCLOCK_H

  #define COS(X)     cos( (X) * 3.14159/180.0 ) // X in Grad
  #define SIN(X)     sin( (X) * 3.14159/180.0 ) // X in Grad
  #define CR         13
  #define ESC        27

  #define CLK_RAD   11          // Radius der Uhr
  #define LGTHMNT   (CLK_RAD-1) // Laenge Min-Zeiger
  #define LGTHHOR   (LGTHMNT-1) // Laenge Std-Zeiger
  #define SMBLMNT   '\333'      // Symbol Min-Zeiger
  #define SMBLHOR   '\262'      // Symbol Std-Zeiger

  enum {X=0, Y=1, Z=2};

  /* Datentyp Uhrzeiger: */
  typedef struct pnt2pnt /* (Strukturname) */
  { float vtx[2][4];     /* Vertices */
    float posMat[4*4];   /* position matrix */
    char  symbol;
  } conClkHnd;           /* (Typname) */

  /*Prototypen:*/
  void conDrawClock (void);
  void conHandInit  (conClkHnd *hand, float length, char symbol);
  void conDrawHands (void);
  void conInit      (void);
  void conSetHands  (int hour, int mnt);
  void draw         (void);
  void key          (char k);

#endif  //BRESENCLOCK_H
